using System;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
using System.Text;

namespace ConsoleApplicationStaskMystery
{
    class Program
    {
        static void Main(string[] args)
        {
            Stack<int> s1 = new Stack<int>();
            Stack<int> s2 = new Stack<int>();
            s1.Push(3);
            s1.Push(5);
            s1.Push(6);
            s1.Push(8);
            s2.Push(8);
            s2.Push(3);
            s2.Push(7);
            s2.Push(1);
            Mystery(s1, s2);
            Console.WriteLine("First stack after call Mystery:");
            Console.WriteLine(s1.ToString());
            Console.WriteLine("Second stack after call Mystery:");
            Console.WriteLine(s2.ToString());
            Console.ReadLine();
        }
        public static void Mystery(Stack<int> s1, Stack<int> s2)
        {
            int a, z;
            int x = 0, y = 0;
            Stack<int> s3 = new Stack<int>();
            Stack<int> s4 = new Stack<int>();

            while (!s1.IsEmpty())
            {
                x = s1.Pop();
                s3.Push(x);
            }

            while (!s2.IsEmpty())
            {
                x = s2.Pop();
                s4.Push(x);
            }

            z = 0; a = 0;

            while (!s3.IsEmpty() && !s4.IsEmpty())
            {
                x = s3.Pop();
                y = s4.Pop();
                z = z + x + y;
                a = z % 10;
                s1.Push(a);
                z = z / 10;
            }

            if (z != 0)
                s1.Push(z);
        }

    }
}
